diff --git a/game/client/src/main/resources/shaders/clouds.fsh b/game/client/src/main/resources/shaders/clouds.fsh
index 707540157..7af39eadc 100644
--- a/game/client/src/main/resources/shaders/clouds.fsh
+++ b/game/client/src/main/resources/shaders/clouds.fsh
@@ -30,7 +30,7 @@ uniform sampler2D colortex;
 uniform sampler2D lighttex;
 
 float distance() {
-	vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
+	vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0 - 1.0, gl_FragCoord.z * 2.0 - 1.0, 1.0);
 	fragPos /= fragPos.w;
 
 	return length(fragPos.xyz);
@@ -40,7 +40,7 @@ void main() {
 	vec4 tex = texture(colortex, TexCoord);
 	
 	// Alpha test
-	if(tex.a < 0.1f) {
+	if(tex.a < 0.1) {
 		discard;
 	}
 	
@@ -51,16 +51,16 @@ void main() {
 	
 	vec4 col = Color;
 
-	float fogStrength = 0.0f;
+	float fogStrength = 0.0;
 
-	float end = (fogState.end * 1.5f);
-	float start = fogState.start / (fogState.end * 1.5f);
+	float end = (fogState.end * 1.5);
+	float start = fogState.start / (fogState.end * 1.5);
 
 	fogStrength = distance() / end;
 	fogStrength -= start;
-	fogStrength /= (1.0f - start);
-	fogStrength = clamp(fogStrength, 0.0f, 1.0f);
-	col.a *= 1.0f - fogStrength;
+	fogStrength /= (1.0 - start);
+	fogStrength = clamp(fogStrength, 0.0, 1.0);
+	col.a *= 1.0 - fogStrength;
 	
 	FragColor = tex * col;
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/color_world.fsh b/game/client/src/main/resources/shaders/color_world.fsh
index f74eec6b4..7f3d1bcb4 100644
--- a/game/client/src/main/resources/shaders/color_world.fsh
+++ b/game/client/src/main/resources/shaders/color_world.fsh
@@ -27,7 +27,7 @@ layout (std140) uniform Matrices {
 uniform sampler2D lighttex;
 
 float distance() {
-    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
+    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0 - 1.0, gl_FragCoord.z * 2.0 - 1.0, 1.0);
     fragPos /= fragPos.w;
 
     return length(fragPos.xyz);
@@ -70,7 +70,7 @@ void main() {
     vec4 litColor = vec4(oColor.rgb * clamp(Light, 0, 1), oColor.a);
 
     FragColor = computeFog(oColor);
-    if (FragColor.a < 0.1f) {
+    if (FragColor.a < 0.1) {
         discard;
     }
 }
diff --git a/game/client/src/main/resources/shaders/color_world.vsh b/game/client/src/main/resources/shaders/color_world.vsh
index 15a642158..8a30d9bfa 100644
--- a/game/client/src/main/resources/shaders/color_world.vsh
+++ b/game/client/src/main/resources/shaders/color_world.vsh
@@ -32,7 +32,7 @@ void main() {
     LightMapCoord = aLightmap;
 
     vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
-    float dir1 = max(0.0f, dot(norm, lightSourcePosition1));
-    float dir2 = max(0.0f, dot(norm, lightSourcePosition2));
+    float dir1 = max(0.0, dot(norm, lightSourcePosition1));
+    float dir2 = max(0.0, dot(norm, lightSourcePosition2));
     Light = (lightModelAmbient + lightSourceDiffuse1 * (dir1 + dir2)).xyz;
 }
diff --git a/game/client/src/main/resources/shaders/font.fsh b/game/client/src/main/resources/shaders/font.fsh
index a5146ab49..69ed2922c 100644
--- a/game/client/src/main/resources/shaders/font.fsh
+++ b/game/client/src/main/resources/shaders/font.fsh
@@ -12,7 +12,7 @@ uniform sampler2D lighttex;
 
 void main() {
     FragColor = texture(colortex, TexCoord) * texture(lighttex, Lightmap) * Color * uColor;
-    if (FragColor.a < 0.1f) {
+    if (FragColor.a < 0.1) {
         discard;
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/font.vsh b/game/client/src/main/resources/shaders/font.vsh
index 6c8c69500..66ffb5e4c 100644
--- a/game/client/src/main/resources/shaders/font.vsh
+++ b/game/client/src/main/resources/shaders/font.vsh
@@ -24,7 +24,7 @@ void main() {
     vs_out.size = aSize;
     vs_out.shift = aShift;
     vs_out.color = aColor;
-    vs_out.uv = aUv/256.0f;
-    vs_out.uvSizes = aUvSizes/256.0f;
+    vs_out.uv = aUv/256.0;
+    vs_out.uvSizes = aUvSizes/256.0;
     vs_out.lightmap = aLightmap;
 }
diff --git a/game/client/src/main/resources/shaders/lines.fsh b/game/client/src/main/resources/shaders/lines.fsh
index 856034cf0..228db697d 100644
--- a/game/client/src/main/resources/shaders/lines.fsh
+++ b/game/client/src/main/resources/shaders/lines.fsh
@@ -6,7 +6,7 @@ uniform vec4 uColor;
 
 void main() {
     FragColor = Color * uColor;
-    if (FragColor.a < 0.1f) {
+    if (FragColor.a < 0.1) {
         discard;
     }
 }
diff --git a/game/client/src/main/resources/shaders/particle.fsh b/game/client/src/main/resources/shaders/particle.fsh
index 2d23f4c9e..66678e4fa 100644
--- a/game/client/src/main/resources/shaders/particle.fsh
+++ b/game/client/src/main/resources/shaders/particle.fsh
@@ -10,7 +10,7 @@ uniform sampler2D lighttex;
 
 void main() {
     FragColor = texture(colortex, TexCoord) * texture(lighttex, Lightmap) * Color;
-    if (FragColor.a < 0.1f) {
+    if (FragColor.a < 0.1) {
         discard;
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/post/base.fsh b/game/client/src/main/resources/shaders/post/base.fsh
index 1f1cfc31a..f4a539a0a 100644
--- a/game/client/src/main/resources/shaders/post/base.fsh
+++ b/game/client/src/main/resources/shaders/post/base.fsh
@@ -25,7 +25,7 @@ vec3 cbCorrection(vec3 tex)
 
     if (mode == 4)//Grayscale
     {
-        return vec3((tex.r + tex.g + tex.b) / 3.0f);
+        return vec3((tex.r + tex.g + tex.b) / 3.0);
     }
 
     float L = (17.8824 * tex.r) + (43.5161 * tex.g) + (4.11935 * tex.b);
diff --git a/game/client/src/main/resources/shaders/post/post.fsh b/game/client/src/main/resources/shaders/post/post.fsh
index 180f9656c..bc044ee4d 100644
--- a/game/client/src/main/resources/shaders/post/post.fsh
+++ b/game/client/src/main/resources/shaders/post/post.fsh
@@ -32,7 +32,7 @@ uniform float frameTimeCounter;
 // FXAA defines
 #define FXAA_REDUCE_MIN   (1.0/ 128.0)
 #define FXAA_REDUCE_MUL   (1.0 / 8.0)
-float FXAA_SPAN_MAX = 8.0f * fxaa;
+float FXAA_SPAN_MAX = 8.0 * fxaa;
 
 vec4 applyFXAA(vec2 fragCoord, sampler2D tex, vec2 uViewportSize) {
     vec4 color;
@@ -102,46 +102,46 @@ vec3 adjustColor(vec3 color, float rValue, float gValue, float bValue) {
 }
 
 void Bloom(inout vec3 color) {
-	vec3 blur = vec3(0.0f);
+	vec3 blur = vec3(0.0);
 	
 	int quality = 7 * bloom;
 	float range = 10 * (3 - bloom);
 	
-	float qh = quality / 2.0f - 0.5f;
-	float allStrengths = 0.0f;
+	float qh = quality / 2.0 - 0.5;
+	float allStrengths = 0.0;
 	for(int i=0; i < quality; i++) {
 		for(int j=0; j < quality; j++) {
 			vec2 offset = vec2((i - qh) * range / width, (j - qh) * range / height);
 			
-			float dist = 1.33f - distance(vec2(qh), vec2(i, j)) / qh;
+			float dist = 1.33 - distance(vec2(qh), vec2(i, j)) / qh;
 			
 			float strength = dist;
 			
-			blur += pow(texture(colortex0, TexCoords + offset).rgb, vec3(2.2f)) * strength;
+			blur += pow(texture(colortex0, TexCoords + offset).rgb, vec3(2.2)) * strength;
 			allStrengths += strength;
 		}
 	}
 	
 	blur /= allStrengths;
 	
-	color.rgb *= 1.0f - (bloom * 0.1f);
-	color.rgb += blur.rgb * 0.15f * bloom;
+	color.rgb *= 1.0 - (bloom * 0.1);
+	color.rgb += blur.rgb * 0.15 * bloom;
 }
 
 void HeatHaze(inout vec2 coord, float amount) {
 	float depth = texture(depthtex0, coord.xy).r;
 	float strength = pow(depth, 500);
-	strength = (strength - 0.16) * 2.0f;
-	strength = clamp(strength, 0.0f, 1.0f) * amount;
+	strength = (strength - 0.16) * 2.0;
+	strength = clamp(strength, 0.0, 1.0) * amount;
 	
-	vec2 wave = vec2(0.0f, 0.0f);
+	vec2 wave = vec2(0.0, 0.0);
 	
 	float waveSize = 50;
 	wave.x += sin(coord.y * 1.3 * waveSize + frameTimeCounter * 10);
 	wave.x += sin(coord.y * 5.0 * waveSize + frameTimeCounter * 14);
 	wave.y += sin(coord.x * 1.0 * waveSize + frameTimeCounter * 5) * 2;
 	
-	coord += wave * strength * 0.0001f;
+	coord += wave * strength * 0.0001;
 }
 
 
diff --git a/game/client/src/main/resources/shaders/terrain.fsh b/game/client/src/main/resources/shaders/terrain.fsh
index e7b0b1e1f..5d742d0ea 100644
--- a/game/client/src/main/resources/shaders/terrain.fsh
+++ b/game/client/src/main/resources/shaders/terrain.fsh
@@ -6,6 +6,7 @@ in vec4 Color;
 in vec2 TexCoord;
 in vec2 LightMapCoord;
 in vec3 Light;
+in vec3 Norm;
 
 uniform vec4 uColor;
 uniform vec2 uViewPortSize;
@@ -31,7 +32,7 @@ uniform sampler2D emmisivetex;
 //uniform sampler2D colormasktex;
 
 float distance() {
-    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
+    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0 - 1.0, gl_FragCoord.z * 2.0 - 1.0, 1.0);
     fragPos /= fragPos.w;
 
     return length(fragPos.xyz);
@@ -80,12 +81,13 @@ void main() {
 
     vec4 postColor = oColor * c * uColor;
     vec4 litColor = vec4(postColor.rgb * clamp(Light, 0, 1), postColor.a);
+//    vec4 litColor = vec4(abs(Norm), 1f);
 
     vec4 fColor = computeFog(litColor);
 
 
     FragColor = fColor;
-    if (FragColor.a < 0.1f) {
+    if (FragColor.a < 0.1) {
         discard;
     }
 }
diff --git a/game/client/src/main/resources/shaders/terrain.vsh b/game/client/src/main/resources/shaders/terrain.vsh
index 4df0a92fb..bad079d51 100644
--- a/game/client/src/main/resources/shaders/terrain.vsh
+++ b/game/client/src/main/resources/shaders/terrain.vsh
@@ -9,11 +9,14 @@ out vec4 Color;
 out vec2 TexCoord;
 out vec2 LightMapCoord;
 out vec3 Light;
+out vec3 Norm;
 
 uniform mat4 normalTransform;
 uniform vec4 lightModelAmbient;
-uniform vec4 lightSourcePosition[];
-uniform vec4 lightSourceDiffuse[];
+uniform vec4 lightSourcePosition1;
+uniform vec4 lightSourcePosition2;
+uniform vec4 lightSourceDiffuse1;
+uniform vec4 lightSourceDiffuse2;
 
 uniform mat4 model;
 
@@ -32,8 +35,9 @@ void main() {
     Color = aColor;
     LightMapCoord = aLightmap;
 
-    vec3 norm = normalize(aNormal);
-    float d1 = max(0.0, dot(norm, vec3(-0.2f, 1f, -0.7f)));
-    float d2 = max(0.0, dot(norm, vec3( 0.2f, 1f,  0.7f)));
-    Light = vec3(0.5, 0.5, 0.5) + vec3(0.5, 0.5, 0.5) * clamp(d1 + d2, 0, 1);
+    Norm = normalize(aNormal);
+    vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
+    float dir1 = max(0.0, dot(norm, lightSourcePosition1));
+    float dir2 = max(0.0, dot(norm, lightSourcePosition2));
+    Light = (lightModelAmbient + lightSourceDiffuse1 * (dir1 + dir2)).xyz;
 }
diff --git a/game/client/src/main/resources/shaders/world.fsh b/game/client/src/main/resources/shaders/world.fsh
index 1dd6db044..802eb8b50 100644
--- a/game/client/src/main/resources/shaders/world.fsh
+++ b/game/client/src/main/resources/shaders/world.fsh
@@ -29,7 +29,7 @@ uniform sampler2D colortex;
 uniform sampler2D lighttex;
 
 float distance() {
-    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
+    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0 - 1.0, gl_FragCoord.z * 2.0 - 1.0, 1.0);
     fragPos /= fragPos.w;
 
     return length(fragPos.xyz);
@@ -76,7 +76,7 @@ void main() {
 
 
     FragColor = fColor;
-    if (FragColor.a < 0.1f) {
+    if (FragColor.a < 0.1) {
         discard;
     }
 }
diff --git a/game/client/src/main/resources/shaders/world.vsh b/game/client/src/main/resources/shaders/world.vsh
index e6abd030c..ed183056e 100644
--- a/game/client/src/main/resources/shaders/world.vsh
+++ b/game/client/src/main/resources/shaders/world.vsh
@@ -31,12 +31,12 @@ void main() {
     vec4 p = vec4(aPos, 1);
     gl_Position = matrices.projection * matrices.view * model * p;
 
-    TexCoord = (texture * vec4(aUV, 0.0f, 1.0f)).xy;
+    TexCoord = (texture * vec4(aUV, 0.0, 1.0)).xy;
     Color = aColor;
     LightMapCoord = aLightmap;
 
     vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
-    float dir1 = max(0.0f, dot(norm, lightSourcePosition1));
-    float dir2 = max(0.0f, dot(norm, lightSourcePosition2));
+    float dir1 = max(0.0, dot(norm, lightSourcePosition1));
+    float dir2 = max(0.0, dot(norm, lightSourcePosition2));
     Light = (lightModelAmbient + lightSourceDiffuse1 * (dir1 + dir2)).xyz;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
index f486b5089..2d12717ca 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
@@ -87,7 +87,7 @@ public class BlockLogicAlgae
         final @NotNull Random rand = world.rand;
 
         if (!world.isClientSide) {
-            if (player == null || player.getGamemode().consumeBlocks()) {
+            if (player == null || player.getGamemode().hasBlockConsumption()) {
                 itemStack.stackSize--;
             }
             TilePos queryPos = new TilePos();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index 9fd2d1fb9..f77fe0923 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -37,7 +37,7 @@ public class BlockLogicBed
         int data = world.getBlockData(tilePos);
         final @NotNull TilePosc headPos;
         final @NotNull TilePosc footPos;
-        if (!isBlockFootOfBed(data)) {
+        if (!isBlockHeadOfBed(data)) {
             final int dir = getDirection(data);
             headPos = tilePos;
             footPos = tilePos.add(headBlockToFootBlockMap[dir].getDirection(), new TilePos());
@@ -48,7 +48,7 @@ public class BlockLogicBed
         }
 
         // Check if bed is not complete
-        if (!isBlockFootOfBed(data)) {
+        if (!isBlockHeadOfBed(data)) {
             if (world.getBlock(footPos) != this.block) {
                 return true;
             }
@@ -122,7 +122,7 @@ public class BlockLogicBed
     protected void removeOtherHalf(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int data = world.getBlockData(tilePos);
         final int direction = getDirection(data);
-        if (isBlockFootOfBed(data)) {
+        if (isBlockHeadOfBed(data)) {
             if (world.getBlockId(tilePos.sub(headBlockToFootBlockMap[direction].getDirection(), new TilePos())) != this.block.id()) {
                 world.setBlockIdNotify(tilePos, 0);
             }
@@ -145,7 +145,7 @@ public class BlockLogicBed
     public static final int MASK_IS_OCCUPIED = 0b0000_0100;
     public static final int MASK_DIRECTION = 0b0000_0011;
 
-    public static boolean isBlockFootOfBed(final int meta) {
+    public static boolean isBlockHeadOfBed(final int meta) {
         return (meta & MASK_IS_FOOT) != 0;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
index 76c0777c7..94fe358bf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
@@ -139,7 +139,7 @@ public class BlockLogicCactus
     public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         if (!world.isClientSide) {
             this.growCactusOnTop(world, tilePos);
-            if (player == null || player.getGamemode().consumeBlocks()) {
+            if (player == null || player.getGamemode().hasBlockConsumption()) {
                 itemStack.stackSize--;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
index ae4a7f074..fd7614437 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
@@ -121,7 +121,7 @@ public class BlockLogicCropsPumpkin
         if (world.getBlockData(tilePos) < 5) {
             if (!world.isClientSide) {
                 world.setBlockIdNotify(tilePos, Blocks.PUMPKIN.id());
-                if (player == null || player.getGamemode().consumeBlocks()) {
+                if (player == null || player.getGamemode().hasBlockConsumption()) {
                     itemStack.stackSize--;
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
index 67ae856f1..ffb87b722 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
@@ -120,7 +120,7 @@ public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemeala
         if (world.getBlockData(tilePos) < MAX_GROWTH_STATE) {
             if (!world.isClientSide) {
                 world.setBlockDataNotify(tilePos, MAX_GROWTH_STATE);
-                if (player == null || player.getGamemode().consumeBlocks()) {
+                if (player == null || player.getGamemode().hasBlockConsumption()) {
                     itemStack.stackSize--;
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
index 15d652fce..94dd51f61 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
@@ -117,7 +117,7 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
                 if (world.getSeasonManager().getCurrentSeason() != Seasons.OVERWORLD_SUMMER)
                     return true;
                 world.setBlockDataNotify(tilePos, setGrowthRate(meta, MAX_GROWTH_STATE));
-                if (player == null || player.getGamemode().consumeBlocks()) {
+                if (player == null || player.getGamemode().hasBlockConsumption()) {
                     itemStack.stackSize--;
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
index a4381e965..447ec0dad 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
@@ -96,7 +96,7 @@ public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry impl
                 if(world.getSeasonManager().getCurrentSeason() != Seasons.OVERWORLD_SPRING)
                     return true;
                 world.setBlockDataNotify(tilePos, setGrowthRate(meta, MAX_GROWTH_STATE));
-                if (player == null || player.getGamemode().consumeBlocks()) {
+                if (player == null || player.getGamemode().hasBlockConsumption()) {
                     itemStack.stackSize--;
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
index f741b9fad..3e52c5c49 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
@@ -25,7 +25,7 @@ public class BlockLogicMeshGold extends BlockLogicMesh {
             boolean flag = meshGold.setFilterItem(player, heldItem);
             world.notifyBlocksOfNeighborChange(tilePos, id());
             if(heldItem != null && heldItem.stackSize <= 0) {
-                player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
+                player.inventory.setItem(player.inventory.getCurrentSlot(), null);
             }
             return flag;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
index 106c46fd3..e2ffc3aff 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
@@ -7,7 +7,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
@@ -23,7 +23,7 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated {
 
     @Override
     public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
-        if (player.getGamemode() != Gamemode.creative) {
+        if (player.getGamemode() != Gamemodes.CREATIVE) {
             return false;
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index a78775613..d96ef8f25 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -112,7 +112,7 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
     public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if (!world.isClientSide) {
             if (!canMossSpread(world, tilePos) || !airExposed(world, tilePos)) return false;
-            if (player == null || player.getGamemode().consumeBlocks()) {
+            if (player == null || player.getGamemode().hasBlockConsumption()) {
                 itemStack.stackSize--;
             }
             for (int i = 0; i < 32; i++) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
index 261b8d879..21235eedd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
@@ -51,7 +51,7 @@ public class BlockLogicMushroom extends BlockLogicFlower {
     public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         Random rand = world.rand;
         if (!world.isClientSide && this.canBeBonemealed) {
-            if (player == null || player.getGamemode().consumeBlocks()) {
+            if (player == null || player.getGamemode().hasBlockConsumption()) {
                 itemStack.stackSize--;
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
index befa6e0e7..9079469f3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
@@ -144,7 +144,7 @@ public class BlockLogicRope
             ropesCollected++;
         }
 
-        if (player.getGamemode().consumeBlocks()) {
+        if (player.getGamemode().hasBlockConsumption()) {
             ItemStack stack = new ItemStack(Items.ROPE, ropesCollected);
             player.inventory.insertItem(stack, true);
             if (stack.stackSize > 0) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
index 1ac8e43aa..70566c07e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
@@ -60,7 +60,7 @@ public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements
     public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if (!world.isClientSide) {
             growTree(world, tilePos, world.rand);
-            if (player == null || player.getGamemode().consumeBlocks()) {
+            if (player == null || player.getGamemode().hasBlockConsumption()) {
                 itemStack.stackSize--;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index 4333eb06e..9fc5376de 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -126,7 +126,7 @@ public class BlockLogicSign extends BlockLogic implements IPaintable {
             ItemStack heldItem = player.getHeldItem();
             if (heldItem != null && heldItem.itemID == Items.DUST_GLOWSTONE.id && !signEntity.isGlowing() && heldItem.consumeItem(player)) {
                 signEntity.setGlowing(true);
-                if (player.getGamemode().consumeBlocks()) {
+                if (player.getGamemode().hasBlockConsumption()) {
                     heldItem.stackSize--;
                 }
                 player.addStat(Achievements.LIGHT_SIGN, 1);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
index dff58702a..8dd27b5f6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
@@ -126,7 +126,7 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable {
     public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if (!world.isClientSide) {
             growReedOnTop(world, tilePos);
-            if (player == null || player.getGamemode().consumeBlocks()) {
+            if (player == null || player.getGamemode().hasBlockConsumption()) {
                 itemStack.stackSize--;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index de37cda71..a370135b2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -37,27 +37,27 @@ public class TileEntityActivator extends TileEntity implements Container {
     }
 
     @Override
-    public @Nullable ItemStack getItem(int index)
+    public @Nullable ItemStack getItem(int slot)
     {
-        return dispenserContents[index];
+        return dispenserContents[slot];
     }
 
     @Override
-    public @Nullable ItemStack removeItem(int index, int takeAmount)
+    public @Nullable ItemStack removeItem(int slot, int takeAmount)
     {
-        if(dispenserContents[index] != null)
+        if(dispenserContents[slot] != null)
         {
-            if(dispenserContents[index].stackSize <= takeAmount)
+            if(dispenserContents[slot].stackSize <= takeAmount)
             {
-                ItemStack itemstack = dispenserContents[index];
-                dispenserContents[index] = null;
+                ItemStack itemstack = dispenserContents[slot];
+                dispenserContents[slot] = null;
                 setChanged();
                 return itemstack;
             }
-            ItemStack itemstack1 = dispenserContents[index].splitStack(takeAmount);
-            if(dispenserContents[index].stackSize <= 0)
+            ItemStack itemstack1 = dispenserContents[slot].splitStack(takeAmount);
+            if(dispenserContents[slot].stackSize <= 0)
             {
-                dispenserContents[index] = null;
+                dispenserContents[slot] = null;
             }
             setChanged();
             return itemstack1;
@@ -120,18 +120,18 @@ public class TileEntityActivator extends TileEntity implements Container {
     }
 
     @Override
-    public void setItem(int index, @Nullable ItemStack itemstack)
+    public void setItem(int slot, @Nullable ItemStack stack)
     {
-        dispenserContents[index] = itemstack;
-        if(itemstack != null && itemstack.stackSize > getMaxStackSize())
+        dispenserContents[slot] = stack;
+        if(stack != null && stack.stackSize > getMaxStackSize())
         {
-            itemstack.stackSize = getMaxStackSize();
+            stack.stackSize = getMaxStackSize();
         }
         setChanged();
     }
 
     @Override
-    public String getNameTranslationKey()
+    public @NotNull String getNameTranslationKey()
     {
         return "container.activator.name";
     }
@@ -182,17 +182,17 @@ public class TileEntityActivator extends TileEntity implements Container {
     }
 
     @Override
-    public boolean stillValid(Player entityplayer)
+    public boolean stillValid(@NotNull Player player)
     {
         if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
         {
             return false;
         }
-        return entityplayer.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) <= 64D;
+        return player.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) <= 64D;
     }
 
     @Override
-    public void sortContainer() {
+    public void sort() {
         // Do nothing
     }
 
